/*
	STRUKTUR.C

	Module zum C-Kurs, Teil 15
	http://members.aol.com/pcdbascht/ckmain.htm

	(c) 1998, 1999 Sebastian Cyris
*/

#include "struktur.h"
#include "suchen.h"
#include "sortier.h"
#include <stdio.h>
#include <stdlib.h>

/*
	EINFACHVERKETTE LISTEN
*/

EVL *EvlEinsetzen	(EVL *Start, double Wert)
{

	/* einzufgendes Element */
	EVL	*neu;

	/* Speicher anfordern und Wert setzen*/
	neu = malloc (sizeof (EVL));
	if (neu == NULL) return Start;

	/* neue Element wird Startelement */
	neu->Element = Wert;
	neu->next = Start;

	return neu;
}

EVL *EvlLoeschen	(EVL *Start, int Index)
{
	EVL	*temp, *davor;

	if (Start == NULL) return NULL;
	/* Anfangselement lschen und raus */
	if (Index == 0 ) 
	{
		temp = Start->next;
		free (Start);
		return temp;
	}

	temp = Start;

	/* Solange Index herunterzhlen bis das Element erreicht ist */
	do 
	{
		Index--;
		davor = temp;
		temp = temp->next;
	} while ((temp->next != NULL) && (Index != 0));

	/* Wenn der Index nicht existiert, dann Liste zurckgeben */
	if (Index != 0) return Start;

	/* zeiger umbiegen und Speicher freigeben */
	davor->next = temp->next;
	free(temp);

	/* Listenstart zurckgeben */
	return Start;
}


void evlZeigen	(EVL *Start)
{
	EVL	*temp;

	if (Start == NULL) return;
	temp = Start;

	do
	{
		printf ("\n%lf",temp->Element);
		temp=temp->next;
	} while (temp != NULL);
}

/*
	STACK REALISATION
*/

EVL *Push (EVL *Stack, double Wert) 
{ 
	return EvlEinsetzen	(Stack, Wert);
} 

EVL *Pop (EVL *Stack) 
{
	if (Stack == NULL) return NULL;

	printf("\n%lf\n",Stack->Element);
	return EvlLoeschen	(Stack, 0);
}

/*
	QUEUE REALISATION
*/

/* Legt einen Wert auf die Queue */ 

EVL *Put (EVL *Queue, double Wert)  
{  
	return EvlEinsetzen (Queue, Wert);
}  

/* Entnimmt den Wert von der Queue und gibt ihn aus */ 

EVL *Get (EVL *Queue)  
{ 
	int Letzter=0;
	EVL *temp = Queue;

	if (Queue == NULL) return NULL; 

	while (temp->next != NULL)
	{
		temp = temp->next;
		Letzter++;
	}
	printf("\n%lf\n",temp->Element); 
	
	return EvlLoeschen (Queue, Letzter);
}

/* Bume und Knoten, Wurzeln und Bltter.... ein Wald ? */


void besuchen (Knoten *Baum) 
{ 
	if (Baum == NULL) return; 
	besuchen (Baum->r); 
	/*
		Nun kann man auf Baum->key zugreifen
	*/
	besuchen (Baum->l); 
}

void besuchenL (EVL *Baum) 
{ 
	while (Baum != NULL)
	{
		/* Nun kann man auf Baum->key zugreifen */
		Baum = Baum->next;
	}
}

